/*
 * This file is a part of CMSLU -- Content Management System like Unix
 * and is not publicly distributed
 * 
 * Copyright (c) 2008-2009, Tomasz Sowa
 * All rights reserved.
 * 
 */
 
#ifndef headerfilecmslucontentcontent
#define headerfilecmslucontentcontent

#include <cstdlib>
#include <fcgiapp.h>
#include <ctime>

#include "../core/item.h"
#include "../templates/templates.h"


class Content
{
	Templates templates;



	
	void PrepareUrl(Item & item);
	
	
	void SetDefaultFunctionForFile();
	void SetDefaultFunctionForDir();
	void SetDefaultFunction();
	bool DirsHaveReadExecPerm();

	void MakeStandardFunction();
	
	
	
	void MakePost();
	
	void FunCat();
	void FunLogout();
	void FunLs();
	void FunEmacs();
	void FunPriv();

	void FunRmDirRecursive();
	void FunRmDir();
	void FunRm();

	void FunNode();
	void FunMkdir();
	void FunDefault();
	void FunRun();
	void FunWho();
	void FunLast();
	void FunThread();
	void FunCreateThread();
	
	void PostFunLogin();
	void PostFunEmacsAdd();
	void PostFunEmacsEdit(bool with_url);
	void PostFunEmacs();
	void PostFunMkdir(bool add_to_dir_table = false);
	long PostFunDefaultParsePath();
	void PostFunDefault();
	void PostFunPriv();
	
	bool FunCreateThreadCheckAccess();
	void PostFunCreateThread();

	void RedirectTo(const Item & item);
	void RedirectTo(long item_id);
	
public:

	bool Init();
	
	void ReadAdditionalInfo();
	void Make();
	

};


#endif
