/*
 * This file is a part of CMSLU -- Content Management System like Unix
 * and is not publicly distributed
 * 
 * Copyright (c) 2009, Tomasz Sowa
 * All rights reserved.
 * 
 */


#ifndef headerfilecmslucoremount
#define headerfilecmslucoremount

#include <set>
#include <string>


class Mount
{
public:


	enum Type
	{
		cms = 0,
		thread
	};


	enum Param
	{
		none = 0,
		asc,
		desc	
	};


	long dir_id;	
	Type type;

	Mount();
	const char * TypeToStr();
	bool ParseStrParam(const std::string & param);
	bool IsParam(Param p);
	
private:
	std::set<Param> param_table;
	
};




#endif

