/*
 * This file is a part of CMSLU -- Content Management System like Unix
 * and is not publicly distributed
 * 
 * Copyright (c) 2008-2009, Tomasz Sowa
 * All rights reserved.
 * 
 */
 
#ifndef headerfilecmslucoreuser
#define headerfilecmslucoreuser

#include <string>
#include <vector>



struct User
{
	long id;
	std::string name;
	bool super_user;
	std::vector<long> groups;
	
	User()
	{
		Clear();
	}
	
	
	void Clear()
	{
		id = -1;
		name.clear();
		super_user = false;
		groups.clear();
	}
	
	
	bool IsMemberOf(long group)
	{
	std::vector<long>::iterator i;
		
		for(i=groups.begin() ; i!=groups.end() ; ++i)
			if( *i == group )
				return true;
				
	return false;
	}
	
	
};


#endif
